﻿using System.Collections.ObjectModel;
using DragDropFrameworkPOC.BaseClasses;

namespace DragDropFrameworkPOC
{
  public class MainWindowViewModel:ViewModelBase
  {
    #region Public Properties

    /// <summary>
    /// Gets the catalog of Living beings
    /// </summary>
    public ObservableCollection<LivingBeing> LivingBeingCatalog { get; set; }

    /// <summary>
    /// Gets or sets the Zoo
    /// </summary>
    public ZooViewModel Zoo
    {
      get { return _zoo; }
      set {
        if (_zoo != value)
        {
          _zoo = value;
          OnPropertyChange(() => Zoo);
        }
      }
    }

    /// <summary>
    /// Gets or sets the neighbourhood.
    /// </summary>
    public NeighbourHoodViewModel Neighbourhood
    {
      get { return _neighbourhood; }
      set {
        if (_neighbourhood != value)
        {
          _neighbourhood = value;
          OnPropertyChange(() => Neighbourhood);
        }
      }
    }

    #endregion


    #region CTOR

    public MainWindowViewModel()
    {
      LivingBeingCatalog=new ObservableCollection<LivingBeing>(DataSouce.GetLivingThings());
      Zoo=new ZooViewModel();
      Neighbourhood=new NeighbourHoodViewModel();
    }

    #endregion

    #region Base Class overrides

    protected override string VerifyPropertyValue(string propertyName)
    {
      return null;
    }

    #endregion

    #region Private Members

    private ZooViewModel _zoo;
    private NeighbourHoodViewModel _neighbourhood;


    #endregion
  }
}