﻿using System.Collections.ObjectModel;
using DragDropFrameworkPOC.BaseClasses;

namespace DragDropFrameworkPOC
{
  public class NeighbourHoodViewModel:ViewModelBase,IDropTarget
  {
    #region Public Properties

    /// <summary>
    /// Gets or sets the neighbourhood where only humans can stay
    /// </summary>
    public ObservableCollection<Person> HumanCollection { get; set; }

    #endregion

    #region CTOR

    public NeighbourHoodViewModel()
    {
      HumanCollection = new ObservableCollection<Person>();
    }

    #endregion

    #region Base Class overrides

    protected override string VerifyPropertyValue(string propertyName)
    {
      return null;
    }

    #endregion

    #region 

    public bool IsDropTarget
    {
      get { return true; }
    }

    public void OnDropped(object arg)
    {
      if (arg is Person)
      {
        HumanCollection.Add(arg as Person);
      }
    }

    public ObservableCollection<string> DropChannels
    {
      get { return GetDropChannels(); }
    }

    private ObservableCollection<string> GetDropChannels()
    {
      return new ObservableCollection<string>()
        {
          Channels.HumanChannel
        };
    }

    #endregion

  }
}